Arch Rebar/cs: Difference between revisions

From FreeCAD Documentation
(Created page with "Category:Arch/cs")
(Updating to match new version of source page)
Line 1: Line 1:
<languages/>
<languages/>
<div class="mw-translate-fuzzy">
{{GuiCommand/cs|Name=Arch Rebar|Name/cs=Arch Rebar|Workbenches=[[Arch Module/cs|Arch]]|MenuLocation=Arch → Rebar|Shortcut=R B|SeeAlso=[[Arch Structure/cs|Arch Structure]]}}
{{GuiCommand/cs|Name=Arch Rebar|Name/cs=Arch Rebar|Workbenches=[[Arch Module/cs|Arch]]|MenuLocation=Arch → Rebar|Shortcut=R B|SeeAlso=[[Arch Structure/cs|Arch Structure]]}}
</div>


==Description==
==Description==


The Rebar tool allows you to place [http://en.wikipedia.org/wiki/Rebar reinforcing bars] inside [[Arch Structure]] objects. Rebar objects are based on 2D profiles such as [[Sketcher Module|sketches]] or [[Draft Module|draft objects]], that must be drawn on a face of a structure object. You can then adjust the configuration of the rebars, such as the number and diameter of the bars, or the offset distance between the two ends of the structural element.
The [[Arch Rebar]] tool allows you to place [http://en.wikipedia.org/wiki/Rebar reinforcing bars] inside [[Arch Structure]] objects.


Rebar objects are based on 2D profiles such as [[Draft Workbench|Draft objects]] and [[Sketcher Workbench|Sketches]], that must be drawn on a face of the structural object. After creation you can adjust the properties of the rebar, including the number and diameter of the bars, and the offset distance between them and the faces of the structural element.
[[Image:Arch Rebar example.jpg|400px]]


[[Image:Arch Rebar example.jpg|400px]]
The above image shows a structural object, where two sketches are drawn, defining two bar diagrams. These two sketches are then turned into rebar objects.
{{Caption|Structural object with two sketches drawn on its faces, which are then turned into two sets of rebar objects}}


== Extension available ==
== Extension available ==


The Rebar tool is enhanced by the [[Reinforcement Addon]], which is installed by the [[Addon Manager]]. The additional rebar types available with the addon are:
The Rebar tool has been greatly enhanced during the [[Google Summer of Code]] 2017 edition. The result of that work is a series of new presets and wizards for the most common rebar types. They are packaged under an independent module called '''Reinforcement''', that you can install via menu Tools -> Addons Manager. Once the Reinforcement addon is installed, on next run, FreeCAD will detect it and add a series of new tools under the Rebar button in the Arch toolbar and menu:
* [[Image:Arch_Rebar_Straight.svg|32px]] [[Arch_Rebar_Straight|Straight Rebar]]

* [[Image:Arch_Rebar_UShape.svg|32px]] [[Arch_Rebar_UShape|UShape Rebar]]
* [[Image:Arch_Rebar_Straight.png|32px]] [[Arch_Rebar_Straight|Straight Rebar]]: Creates a Straight reinforcement bar in a selected structural element
* [[Image:Arch_Rebar_UShape.png|32px]] [[Arch_Rebar_UShape|UShape Rebar]]: Creates a UShape reinforcement bar in a selected structural element
* [[Image:Arch_Rebar_LShape.svg|32px]] [[Arch_Rebar_LShape|LShape Rebar]]
* [[Image:Arch_Rebar_BentShape.svg|32px]] [[Arch_Rebar_BentShape|Bent Shape Rebar]]
* [[Image:Arch_Rebar_LShape.png|32px]] [[Arch_Rebar_LShape|LShape Rebar]]: Creates a LShape reinforcement bar in a selected structural element
* [[Image:Arch_Rebar_Stirrup.svg|32px]] [[Arch_Rebar_Stirrup|Stirrup Rebar]]
* [[Image:Arch_Rebar_BentShape.png|32px]] [[Arch_Rebar_BentShape|Bent Shape Rebar]]: Creates a Bent Shape reinforcement bar in a selected structural element
* [[Image:Arch_Rebar_Stirrup.png|32px]] [[Arch_Rebar_Stirrup|Stirrup Rebar]]: Creates a Stirrup reinforcement bar in a selected structural element
* [[Image:Arch_Rebar_Helical.svg|32px]] [[Arch_Rebar_Helical|Helical Rebar]]
* [[Image:Arch_Rebar_Helical.png|32px]] [[Arch_Rebar_Helical|Helical Rebar]]: Creates a Helical reinforcement bar in a selected structural element


==How to use==
==How to use==


# Create a [[Arch Structure|structure]] element
# Create an {{Button|[[Image:Arch_Structure.svg|16px]] [[Arch Structure]]}} element.
# Switch to the [[Sketcher Workbench]]
# Switch to the [[Sketcher Workbench]].
# Select one face of the structural element
# Select one face of the structural element.
# Press the {{KEY|[[Image:Sketcher NewSketch.png|16px]] [[Sketcher NewSketch|New Sketch]]}} button to start a new sketch on the selected face
# Press the {{Button|[[Image:Sketcher NewSketch.svg|16px]] [[Sketcher NewSketch|New Sketch]]}} button to start a new sketch on the selected face.
# Draw the diagram of your bar
# Draw the diagram of your bar.
# Press the {{KEY|[[Image:Sketcher LeaveSketch.png|16px]] [[Sketcher LeaveSketch|Leave Sketch]]}} button to finish
# Press the {{Button|[[Image:Sketcher LeaveSketch.svg|16px]] [[Sketcher LeaveSketch|Leave Sketch]]}} button to finish.
# Switch back to the [[Arch Workbench]]
# Switch back to the [[Arch Workbench]].
# Select the sketch you just drew
# Select the sketch you just drew.
# Press the {{KEY|[[Image:Arch Rebar.png|16px]] [[Arch Rebar]]}} button, or press {{KEY|R}} then {{KEY|B}} keys
# Press the {{Button|[[Image:Arch Rebar.svg|16px]] [[Arch Rebar]]}} button, or press {{KEY|R}} then {{KEY|B}} keys.
# Adjust the desired properties (your rebar might not appear immediately, if some of the properties create an impossible situation, such as the bar diameter being 0, or the offset distances being bigger than the length of the structural element)
# Adjust the desired properties (your rebar might not appear immediately, if some of the properties create an impossible situation, such as the bar diameter being 0, or the offset distances being bigger than the length of the structural element).


==Options==
==Options==
Line 53: Line 55:


==Scripting==
==Scripting==
{{Emphasis|See also:}} [[Arch API]] and [[FreeCAD Scripting Basics]].


The Rebar tool can by used in [[macros]] and from the python console by using the following function:
The Rebar tool can be used in [[macros]] and from the [[Python]] console by using the following function:
{{Code|code=
{{Code|code=
makeRebar (structure,sketch,[diameter],[amount],[offset])
Rebar = makeRebar(baseobj=None, sketch=None, diameter=None, amount=1, offset=None, name="Rebar")
}}
}}


* Adds a Reinforcing Bar object to the given structural object, using the given sketch as profile.
* Creates a {{incode|Rebar}} object from the given {{incode|baseobj}}, which is an [[Arch Structure]], and a {{incode|sketch}} as profile.
* If no diameter, amount or offset value is given, the default values from the Arch preferences settings are applied.
** {{incode|diameter}}, {{incode|amount}}, and {{incode|offset}} are used to define the characteristics of the bars.
** If no {{incode|diameter}}, {{incode|amount}}, or {{incode|offset}} values are given, the default values from the [[Arch Preferences]] are used.
* Returns the new Rebar object.


Example:
Example:
{{Code|code=
{{Code|code=
import FreeCAD, Arch, Sketcher, PArt
import FreeCAD, Arch, Part
struct = Arch.makeStructure(1,1,3)
sketch = FreeCAD.ActiveDocument.addObject('Sketcher::SketchObject','Sketch')
sketch.Support = (struct,["Face6"])
sketch.addGeometry(Part.Line(App.Vector(-0.4,0.4,0),App.Vector(0.4,0.4,0)))
Arch.makeRebar(structure,sketch)
}}


Structure = Arch.makeStructure(None, length=1000, width=1000, height=3000)
Structure.ViewObject.Transparency = 80
FreeCAD.ActiveDocument.recompute()

p1 = FreeCAD.Vector(-400, 400, 0)
p2 = FreeCAD.Vector(400, 400, 0)
Sketch = FreeCAD.ActiveDocument.addObject('Sketcher::SketchObject', 'Sketch')
Sketch.MapMode = "FlatFace"
Sketch.Support = [(Structure, "Face6")]
Sketch.addGeometry(Part.LineSegment(p1, p2))
FreeCAD.ActiveDocument.recompute()

Rebar = Arch.makeRebar(Structure, Sketch, diameter=80, amount=7, offset=50)
Rebar.OffsetStart = 100
Rebar.OffsetEnd = 100
FreeCAD.ActiveDocument.recompute()
}}
<div class="mw-translate-fuzzy">
[[Category:Arch/cs]]
[[Category:Arch/cs]]
</div>

Revision as of 16:33, 9 February 2019

Arch Rebar

Umístění Menu
Arch → Rebar
Pracovní stoly
Arch
Výchozí zástupce
R B
Představen ve verzi
-
Viz také
Arch Structure

Description

The Arch Rebar tool allows you to place reinforcing bars inside Arch Structure objects.

Rebar objects are based on 2D profiles such as Draft objects and Sketches, that must be drawn on a face of the structural object. After creation you can adjust the properties of the rebar, including the number and diameter of the bars, and the offset distance between them and the faces of the structural element.

Structural object with two sketches drawn on its faces, which are then turned into two sets of rebar objects

Extension available

The Rebar tool is enhanced by the Reinforcement Addon, which is installed by the Addon Manager. The additional rebar types available with the addon are:

How to use

  1. Create an Arch Structure element.
  2. Switch to the Sketcher Workbench.
  3. Select one face of the structural element.
  4. Press the New Sketch button to start a new sketch on the selected face.
  5. Draw the diagram of your bar.
  6. Press the Leave Sketch button to finish.
  7. Switch back to the Arch Workbench.
  8. Select the sketch you just drew.
  9. Press the Arch Rebar button, or press R then B keys.
  10. Adjust the desired properties (your rebar might not appear immediately, if some of the properties create an impossible situation, such as the bar diameter being 0, or the offset distances being bigger than the length of the structural element).

Options

  • Rebars share the common properties and behaviours of all Arch Components
  • The rounding value is expressed in times the diameter. If your bar has a diameter of 5mm, a rounding value of 3 will create rounding at angles with a radius of 15mm.
  • Default values for new rebars can be set in the Arch preferences settings.
  • If a direction vector is not specified, the direction and distance along which the bars will spread is calculated automatically from the host structural object, by taking the normal direction of the base sketch, and taking its intersection with the structural object. If you specify a direction vector, the length of that vector will also be taken into account.
  • The spacing value is calculated from the current amount of bars, and represents the distance between the axes of each bar. You must therefore subtract the bar diameter to obtain the size of the free space between bars.

Properties

  • ÚdajeAmount: The amount of bars.
  • ÚdajeDiameter: The diameter of the bars.
  • ÚdajeDirection: The direction (and length) along which the bars must spread. If the value is (0,0,0), the direction is calculated automatically from the host structural object.
  • ÚdajeOffset Start: The offset distance between the border of the structural object and the first bar.
  • ÚdajeOffset End: The offset distance between the border of the structural object and the last bar.
  • ÚdajeRounding: A rounding value to be applied to the corners of the bars, expressed in times the diameter.
  • ÚdajeSpacing: The distance between the axes of each bar.

Scripting

See also: Arch API and FreeCAD Scripting Basics.

The Rebar tool can be used in macros and from the Python console by using the following function:

Rebar = makeRebar(baseobj=None, sketch=None, diameter=None, amount=1, offset=None, name="Rebar")
  • Creates a Rebar object from the given baseobj, which is an Arch Structure, and a sketch as profile.
    • diameter, amount, and offset are used to define the characteristics of the bars.
    • If no diameter, amount, or offset values are given, the default values from the Arch Preferences are used.

Example:

import FreeCAD, Arch, Part

Structure = Arch.makeStructure(None, length=1000, width=1000, height=3000)
Structure.ViewObject.Transparency = 80
FreeCAD.ActiveDocument.recompute()

p1 = FreeCAD.Vector(-400, 400, 0)
p2 = FreeCAD.Vector(400, 400, 0)
Sketch = FreeCAD.ActiveDocument.addObject('Sketcher::SketchObject', 'Sketch')
Sketch.MapMode = "FlatFace"
Sketch.Support = [(Structure, "Face6")]
Sketch.addGeometry(Part.LineSegment(p1, p2))
FreeCAD.ActiveDocument.recompute()

Rebar = Arch.makeRebar(Structure, Sketch, diameter=80, amount=7, offset=50)
Rebar.OffsetStart = 100
Rebar.OffsetEnd = 100
FreeCAD.ActiveDocument.recompute()